import { ExecutableTool, JSONSchema, ToolInputSchema } from '../types';
import type { ToolResultContentBlock } from '@aws-sdk/client-bedrock-runtime';
import { GraphqlRequestExecutor } from '../graphql_request_executor';
/**
 * A tool that use GraphQl queries.
 */
export declare class GraphQlTool implements ExecutableTool<JSONSchema, unknown> {
    name: string;
    description: string;
    inputSchema: ToolInputSchema<JSONSchema>;
    readonly graphQlEndpoint: string;
    private readonly query;
    readonly accessToken: string;
    readonly userAgent: string;
    private readonly graphqlRequestExecutor;
    /**
     * Creates GraphQl Tool
     */
    constructor(name: string, description: string, inputSchema: ToolInputSchema<JSONSchema>, graphQlEndpoint: string, query: string, accessToken: string, userAgent: string, graphqlRequestExecutor?: GraphqlRequestExecutor);
    execute: (input: unknown | undefined) => Promise<ToolResultContentBlock>;
}
//# sourceMappingURL=graphql_tool.d.ts.map