"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.convertNamedTypeToJSONSchema = void 0;
const graphql_scalar_json_schema_definitions_1 = require("./graphql-scalar-json-schema-definitions");
const convertNamedTypeToJSONSchema = (namedType) => {
    switch (namedType.name.value) {
        case 'Int':
            return graphql_scalar_json_schema_definitions_1.GraphQLScalarJSONSchemaDefinition.Int;
        case 'Float':
            return graphql_scalar_json_schema_definitions_1.GraphQLScalarJSONSchemaDefinition.Float;
        case 'String':
            return graphql_scalar_json_schema_definitions_1.GraphQLScalarJSONSchemaDefinition.String;
        case 'ID':
            return graphql_scalar_json_schema_definitions_1.GraphQLScalarJSONSchemaDefinition.ID;
        case 'Boolean':
            return graphql_scalar_json_schema_definitions_1.GraphQLScalarJSONSchemaDefinition.Boolean;
        case 'AWSJSON':
            return graphql_scalar_json_schema_definitions_1.GraphQLScalarJSONSchemaDefinition.AWSJSON;
        case 'AWSEmail':
            return graphql_scalar_json_schema_definitions_1.GraphQLScalarJSONSchemaDefinition.AWSEmail;
        case 'AWSDate':
            return graphql_scalar_json_schema_definitions_1.GraphQLScalarJSONSchemaDefinition.AWSDate;
        case 'AWSTime':
            return graphql_scalar_json_schema_definitions_1.GraphQLScalarJSONSchemaDefinition.AWSTime;
        case 'AWSDateTime':
            return graphql_scalar_json_schema_definitions_1.GraphQLScalarJSONSchemaDefinition.AWSDateTime;
        case 'AWSTimestamp':
            return graphql_scalar_json_schema_definitions_1.GraphQLScalarJSONSchemaDefinition.AWSTimestamp;
        case 'AWSPhone':
            return graphql_scalar_json_schema_definitions_1.GraphQLScalarJSONSchemaDefinition.AWSPhone;
        case 'AWSURL':
            return graphql_scalar_json_schema_definitions_1.GraphQLScalarJSONSchemaDefinition.AWSURL;
        case 'AWSIPAddress':
            return graphql_scalar_json_schema_definitions_1.GraphQLScalarJSONSchemaDefinition.AWSIPAddress;
        default:
            return {
                type: 'object',
                properties: {},
                required: [],
            };
    }
};
exports.convertNamedTypeToJSONSchema = convertNamedTypeToJSONSchema;
//# sourceMappingURL=named-type-conversion.js.map