"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.makeConnectionField = void 0;
const definition_1 = require("./definition");
const ModelResourceIDs_1 = require("./ModelResourceIDs");
function makeConnectionField(fieldName, returnTypeName, args = [], directives = []) {
    return (0, definition_1.makeField)(fieldName, [
        ...args,
        (0, definition_1.makeInputValueDefinition)('filter', (0, definition_1.makeNamedType)(ModelResourceIDs_1.ModelResourceIDs.ModelFilterInputTypeName(returnTypeName))),
        (0, definition_1.makeInputValueDefinition)('limit', (0, definition_1.makeNamedType)('Int')),
        (0, definition_1.makeInputValueDefinition)('nextToken', (0, definition_1.makeNamedType)('String')),
    ], (0, definition_1.makeNamedType)(ModelResourceIDs_1.ModelResourceIDs.ModelConnectionTypeName(returnTypeName)), directives);
}
exports.makeConnectionField = makeConnectionField;
//# sourceMappingURL=connectionUtils.js.map